



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>（转）freemakeer初入门</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">（转）freemakeer初入门</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 05:28:55 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>在web开发过程中，尤其是后台管理系统的开发中，少不了增删改成的基础操作，原来我自己的做法是一份一份的拷贝粘贴，然后修改其中的不同，然而这样既枯燥无味又浪费了大量的时间，所以根据自己项目结构的特点写了一个自动生成结构代码的工具jar包，可以根据数据库表直接生成相应数据库模型对象（DMO）以及对表的增删改查代码。</p>
<p>之前我考虑过多种自动生成代码的提供方式，比如web的方式，通过在页面文本框里面输入各种参数，比如模板文件地址，生成文件地址，数据库名，数据库用户名和密码等，点击生成按钮就可以生成源代码文件。但这样需要部署启动这个web程序。使用java的图形用户界面，但我对java图形的相关API并不了解，最后决定使用一个jar包的方式，方便简洁。</p>
<p>由于模板文件使用的是freemarker，数据库使用的是mysql，所以引入其他的两个jar文件。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/853981/201602/853981-20160216184833642-395799878.png" /></p>
<p>如上图，AutoGenerationJavaCode.jar 是将原本工程里的&nbsp;AutoGenerationJavaCode.java文件打包生成的，也是最终的形式。通过在AutoGenerationDemo类main函数中设置参数，直接调用即可自动生成代码。</p>
<p>配置好参数后在左图右键运行java程序即可生成右图代码文件：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/853981/201602/853981-20160216190416282-69038185.png" />&nbsp; &nbsp; &nbsp;<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/853981/201602/853981-20160216190926220-2020496807.png" /></p>
<p>调用如下：</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums"> 1 public class AutoGenerationDemo {<br />
 2<br />
 3     public static void main(String[] args) throws ClassNotFoundException, SQLException, IOException, TemplateException {<br />
 4         //数据库地址<br />
 5         String url = "jdbc:mysql://10.27.209.137:3306/sample";<br />
 6         //用户名<br />
 7         String name = "root";<br />
 8         //密码<br />
 9         String passWord = "root";<br />
10         //驱动<br />
11         String driver = "com.mysql.jdbc.Driver";<br />
12         //表名<br />
13         String tableName = "t_operate_log";<br />
14         //模板路径<br />
15         String templateDir = "F:\\template";<br />
16         //生成文件路径<br />
17         String autoGeneratedFile = "F:\\autoGenerated";<br />
18         //实例化<br />
19         AutoGenerationJavaCode autoGenerationJavaCode = new AutoGenerationJavaCode(url, name, passWord, driver,<br />
20                 tableName,autoGeneratedFile,templateDir);<br />
21<br />
22         //调用生成java代码方法<br />
23         autoGenerationJavaCode.autoGenerationJavaCode();<br />
24     }<br />
25<br />
26 }</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>在main方法中配置好所需参数，由于代码包含注释，不在赘述，调用jar包中&nbsp;AutoGenerationJavaCode的autoGenerationJavaCode方法即可生成，控制台会打印文件生产完成</p>
<p>我的Web项目的结构采用的是三层结构，Controller层调用service层，从service层调用dao层（数据操作层），所以决定自己生成service层，dao层代码。其实质就是将模板文件中的变量进行替换。模板文件及对应生成的java代码如下：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/853981/201602/853981-20160216192053861-674901699.png" />&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;&nbsp;<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/853981/201602/853981-20160216192231814-1318272322.png" /></p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/853981/201602/853981-20160216193143001-70135921.png" />&nbsp; &nbsp; &nbsp; &nbsp; &nbsp;&nbsp;<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/853981/201602/853981-20160216193315564-1536420998.png" /></p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/853981/201602/853981-20160216193748798-227991025.png" />&nbsp; &nbsp;&nbsp;<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/853981/201602/853981-20160216193847157-591186136.png" /></p>
<p>jar包的源代码如下：</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">package com.sun.autoGenerated;

import java.io.BufferedWriter;<br />
import java.io.File;<br />
import java.io.FileOutputStream;<br />
import java.io.IOException;<br />
import java.io.OutputStreamWriter;<br />
import java.io.Writer;<br />
import java.sql.Connection;<br />
import java.sql.DriverManager;<br />
import java.sql.PreparedStatement;<br />
import java.sql.ResultSetMetaData;<br />
import java.sql.SQLException;<br />
import java.util.HashMap;<br />
import java.util.Map;

import freemarker.template.Configuration;<br />
import freemarker.template.Template;<br />
import freemarker.template.TemplateException;

public class AutoGenerationJavaCode {

    private String url;<br />
    private String name;<br />
    private String passWord;<br />
    private String driver;<br />
    private String sql;<br />
    private String tableName;<br />
    private String templateDir;<br />
    private String autoGeneratedFile;<br />
    private static String[][] fileNameArray = new String[5][2];

    static {<br />
        fileNameArray[0][0] = "dmoTemplate.ftl";<br />
        fileNameArray[0][1] = "DMO.java";

        fileNameArray[1][0] = "serviceTemplate.ftl";<br />
        fileNameArray[1][1] = "Service.java";

        fileNameArray[2][0] = "serviceImplTemplate.ftl";<br />
        fileNameArray[2][1] = "ServiceImpl.java";

        fileNameArray[3][0] = "daoTemplate.ftl";<br />
        fileNameArray[3][1] = "Dao.java";

        fileNameArray[4][0] = "daoImplTemplate.ftl";<br />
        fileNameArray[4][1] = "DaoImpl.java";<br />
    }

    public AutoGenerationJavaCode(String url, String name, String passWord, String driver, String tableName,<br />
           String autoGeneratedFile,String templateDir) {<br />
        this.url = url;<br />
        this.name = name;<br />
        this.passWord = passWord;<br />
        this.driver = driver;<br />
        this.sql = "select * from " + tableName;<br />
        this.tableName = tableName;<br />
        this.templateDir = templateDir;<br />
        this.autoGeneratedFile = autoGeneratedFile;<br />
    }

    public void autoGenerationJavaCode() throws IOException, TemplateException, ClassNotFoundException,<br />
            SQLException {<br />
        Configuration cfg = new Configuration();<br />
        cfg.setDefaultEncoding("utf-8");

        String className = dealTableName();

        String fileName = dealClassName(className);<br />
        Map&lt;String, Object&gt; columnMap = getColumn();<br />
        //设置模板文件路径<br />
        cfg.setDirectoryForTemplateLoading(new File(templateDir));

        Map&lt;String, Object&gt; rootMap = new HashMap&lt;String, Object&gt;();<br />
        rootMap.put("className", className);<br />
        rootMap.put("columnMap", columnMap);<br />
        File dir = new File(autoGeneratedFile + "\\");<br />
        //检查目录是否存在，不存在则创建<br />
        if (!dir.exists()) {<br />
            dir.mkdir();<br />
        }<br />
        for (int i = 0; i &lt; fileNameArray.length; i++) {

            Template temp = cfg.getTemplate(fileNameArray[i][0]);

            File docFile = new File(autoGeneratedFile + "\\" + fileName + fileNameArray[i][1]);

            Writer docout = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(docFile)));<br />
            //输出文件<br />
            temp.process(rootMap, docout);<br />
        }<br />
        System.out.println("==============文件生产成功===============");

    }

    //获取数据库表字段名放入map中<br />
    public Map&lt;String, Object&gt; getColumn() throws ClassNotFoundException, SQLException {<br />
        Connection conn;<br />
        PreparedStatement pStemt = null;<br />
        Class.forName(driver);<br />
        conn = DriverManager.getConnection(url, name, passWord);<br />
        pStemt = conn.prepareStatement(sql);<br />
        ResultSetMetaData rsmd = pStemt.getMetaData();

        Map&lt;String, Object&gt; columnMap = new HashMap&lt;String, Object&gt;();<br />
        int size = rsmd.getColumnCount();<br />
        for (int i = 0; i &lt; size; i++) {<br />
            String columnName = dealColumnName(rsmd, i);<br />
            columnMap.put(columnName, columnName);<br />
        }<br />
        conn.close();<br />
        return columnMap;<br />
    }

    //将表名转换为DMO的字段名，比如 operate_type 转换后为 operateType<br />
    private String dealColumnName(ResultSetMetaData rsmd, int i) throws SQLException {<br />
        String columnName = rsmd.getColumnName(i + 1).toLowerCase();<br />
        String charAfterLine = String.valueOf(columnName.charAt((columnName.indexOf("_") + 1)));<br />
        String convertedChar = charAfterLine.toUpperCase();<br />
        columnName = columnName.replace("_" + charAfterLine, convertedChar);<br />
        return columnName;<br />
    }

     //将表名转换为类型类名 比如 t_operate_log 转换后为 operateLog ,类名首字母应为大写，这里在freemarker的模板里直接转换<br />
    private String dealTableName() {<br />
        String className = tableName.toLowerCase().substring(tableName.indexOf("_") + 1);<br />
        String charAfterLine = String.valueOf(className.charAt((className.indexOf("_") + 1)));<br />
        String convertedChar = charAfterLine.toUpperCase();<br />
        className = className.replace("_" + charAfterLine, convertedChar);<br />
        return className;<br />
    }

    //将类名转换为文件名，java公共类名与其文件名应该相同，这里将首字母转换为大写 如operateLog 转换后为 OperateLog<br />
    private String dealClassName(String className) {<br />
        String first = className.substring(0, 1).toUpperCase();<br />
        String rest = className.substring(1, className.length());<br />
        String fileName = new StringBuffer(first).append(rest).toString();<br />
        return fileName;<br />
    }

}</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>源码下载：<a href="http://files.cnblogs.com/files/jarman/sourceCode.zip" rel="external nofollow noreferrer">http://files.cnblogs.com/files/jarman/sourceCode.zip</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9pxv7zq.html">css中的一些属性解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq434738.html">TortoiseSVN安装以及淘宝 TAE SDK 开发环境的搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mel5kq.html">leetcode1&colon;在数组中找2个数的和正好等于一个给定值--哈希</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xdvjn9.html">DOM笔记（八）：JavaScript执行环境和垃圾收集</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydj0vxq.html">Appium移动自动化测试（三）--安装Android模拟器（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z74rz9.html">openstack 使用集锦</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xovge8.html">Oracle 执行计划（Explain Plan）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8memgjoq.html">Materialized View in Oracle - Concepts and Architecture</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mvyl48.html">meminfo&comma;df&comma;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpp6439.html">Cocos2d-x Auto-batching 浅浅的&rdquo;深入分析&rdquo;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z65vn9.html">FPGA设计思想与技巧（转载）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zj45j9.html">Ubuntu设置程序开机自启或者开机禁止加载</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzgene8.html">Replacement（思维题）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp6v679.html">数据结构基础&mdash;&mdash;结构体struct及类型别名typedef的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllj3p0q.html">vue自定义滚动条</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjzp509.html">JavaScript异步流程控制的前世今生</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdw4m109.html">python 之 知识点（1）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pzenjq.html">js - 关于循环</a>
		</li>
						<li><a href="https://www.batexi.com/a/953ddmv8.html">&lbrack;工具&rsqb;JSON校验、转换在线工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/963z2m49.html">Nginx 使用（server参数配置）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/0qw6mny9.html">Android Touch事件传递机制解析</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qn3oy29.html">js&colon;语言精髓笔记7----原型继承</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvx4ez8.html">构造 Codeforces Round &num;302 &lpar;Div&period; 2&rpar; B Sea and Islands</a>
			</li>
						<li><a href="https://www.batexi.com/a/495624z8.html">datetime与smalldatetime之间的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvx60z8.html">小明A&plus;B&lbrack;HDU2096&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pzzek8.html">xamarin studio And linq 查询方式分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvg5vxq.html">看看 JDK 8 给我们带来什么&lpar;转&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8epejk9.html">vim 配置 设置搜索 高亮</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnr1v39.html">PHPUnit在Windows下的配置及使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qyedpm9.html">hdu Proud Merchants</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
